###############################################################################
# Journal.pl                                                                 #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################
# This file is part of the Journal which has been created by    #
# Mitchell Maine (majik). Last modification: July 30, 2003                                 #
###############################################################################
# Files used:
# journal.txt ( should be in variables/journal directory )
# journal.dat ( should be in variables/journal directory )
# Journal.pl ( obviously ... )

$registerplver = "1 Gold - SP 1.3";

sub RandNum {my @number=(0..6);my $new;foreach(1..6){$new.=$number[rand(@number)];}return $new;}

sub VJournal {
  
	my($buffer,$counter,$pageindex,$max,$start);
	&LoadCensorList;
	fopen(DFILE,"$vardir/journal/journal.dat") || &fatal_error("Couldn't open $vardir\journal.dat for reading.");
	$totalentries = <DFILE>;
	fclose(DFILE);
	$maxentrydisp = 5;
	# fopen(JFILE,"$vardir/journal/journal.txt") || &fatal_error("Couldn't open $vardir\journal.txt for reading.");
	# @jdata = <JFILE>;	
	# fclose(JFILE);
	$entrynum = -1;


	# Build the page links list.
	$entrydisplaynum = 3;	# max number of pages to display
	$max = $totalentries;
	$start = $INFO{'start'} || 0;
	$start = $start > $totalentries ? $totalentries : $start;
	$start = ( int( $start / $maxentrydisp ) ) * $maxentrydisp;
	$tmpa = 1;
	$tmpx = int( $max / $maxentrydisp );
	if ($start >= (($entrydisplaynum-0) * $maxentrydisp)) { $startpage = $start - (($entrydisplaynum-0) * $maxentrydisp); $tmpa = int( $startpage / $maxentrydisp ) + 1; }
	if ($max >= $start + ($entrydisplaynum * $maxentrydisp)) { $endpage = $start + ($entrydisplaynum * $maxentrydisp); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=journal;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $maxentrydisp) { $pageindex = qq~<a href="$cgi;action=journal;start=0">1</a>&nbsp;~;}
	if ($start != 0) { $previous=$start-$maxentrydisp; $pageindex = qq~&nbsp;<a href="$cgi;action=journal;start=$previous">&#171; $txt{'803'}</a>&nbsp~; }
	for( $counter = $startpage; $counter < $endpage; $counter += $maxentrydisp ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$cgi;action=journal;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $maxentrydisp;
	$outerpn = int($tmpx / $maxentrydisp) + 0;
	$lastpn = int($totalentries / $maxentrydisp) + 0;
	$lastptn = ($lastpn - 0) * $maxentrydisp;
	if ($endpage < $max - ($maxentrydisp) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=journal;start=$lastptn">$lastpn</a>~;}
	if ($start != $lastptn) { $next=$start+$maxentrydisp; $pageindexadd .= qq~&nbsp;<a href="$cgi;action=journal;start=$next">$txt{'804'} &#187;</a>~;}
	$pageindex .= $pageindexadd;

	$counter = 0;

	fopen(JFILE,"$vardir/journal/journal.txt") || &fatal_error("104 $txt{'106'}: $txt{'23'} journal.txt");

	# Skip past the posts in this thread until we reach $start.
	while($counter < $start && ($buffer = <JFILE>)) { $counter++; }

	$#jdata = $maxentrydisp - 1;
	for($counter = 0; $counter < $maxentrydisp && ($buffer = <JFILE>); $counter++) {
		$jdata[$counter] = $buffer;
	}
	fclose(JFILE);
	$#jdata = $counter - 1;
	$counter = $start;
	$yymain .= qq~
<table border="0" width="90%" cellspacing="1" cellpadding="3" align="center">
  <tr>
    <td align="right">Page(s): $pageindex</td>
  </tr>
</table>
~;
	# For each entry:
	foreach(@jdata) {

	$entrynum = $entrynum + 1;
	chomp;
	($jsub, $jname, $jdispname, $jdate, $jmsg, $jedited,$jcomnum) = split(/[\|]/, $_);
	$jdate = &timeformat($jdate);
	
	fopen(CFILE,"$vardir/journal/$jcomnum.data");
	$numcoms = <CFILE>;
	fclose(CFILE);

	# Censor the subject and message.
	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$jmsg =~ s~\Q$tmpa\E~$tmpb~gi;
		$jsub =~ s~\Q$tmpa\E~$tmpb~gi;
	}
	&wrap;
		require "$sourcedir/YaBBC.pl"; 
		$message = $jmsg;
		&DoUBBC;
		$jmsg = $message;
	&wrap2;
	$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<SCRIPT LANGUAGE=JAVASCRIPT TYPE="TEXT/JAVASCRIPT">
<!--Hide script from old browsers

function newWindow(theURL)
 {
  winContent = window.open(theURL, 'nextWin', 'left=200, top=100,width=350,height=350, toolbar=0,scrollbars=1, resizable=0,status=0,directories=0,menubar=0,location=0')         
 }

 //Stop hiding script from old browsers -->
 </script>
<table border="0" width="90%" cellspacing="1" cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" align="left"><font size=1 class="text1" color="$color{'titletext'}"><a name="$counter"></a><img src="$imagesdir/journal.gif" alt="$jtxt{'01'}" border="0"> $jsub</td>
    <td class="titlebg" bgcolor="$color{'titlebg'}" align="right"><font size=1 color="#000000">Posted by: <a href="$scripturl?action=viewprofile;username=$jname">$jdispname</a></td>
  </tr><tr>
    <td colspan="2" class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><BR>$jmsg<BR><BR></font></td>
  </tr><tr>
    <td colspan="2" class="windowbg" bgcolor="$color{'windowbg'}" align="right"><table width="100%" border="0" cellspacing="0" cellpadding="0" align="center"><tr><td width="30%" align="left">~; if ($settings[7] eq "Administrator") { $yymain .= qq~<a href="$cgi;action=ajournal">$img{'jadd'}</a> <a href="$cgi;action=ejournal;entry=$entrynum">$img{'jedit'}</a> <a href="$cgi;action=djournal;entry=$entrynum">$img{'jdel'}</a>~; } $yymain .= qq~</td><td width="40%" align="center">~; if ($numcoms == 0) { $yymain .= qq~<a href="javascript:newWindow('$cgi;action=jcomments;com=$jcomnum')">-= $numcoms $jtxt{'16b'} =-</a>~; } elsif($numcoms == 1) { $yymain .= qq~<a href="javascript:newWindow('$cgi;action=jcomments;com=$jcomnum')">-= $numcoms $jtxt{'16a'} =-</a>~; } elsif ($numcoms > 1) { $yymain .= qq~<a href="javascript:newWindow('$cgi;action=jcomments;com=$jcomnum')">-= $numcoms $jtxt{'16b'} =-</a>~; } $yymain .= qq~</td><td width="30%" align="right">~; if ($jedited eq 0) { $yymain .= qq~$jtxt{'14'} $jdate~; } if ($jedited eq 1) { $yymain .= qq~$jtxt{'15'} $jdate~; } $yymain .= qq~</td></tr></table></td>
</tr>
</table>
~;
	}
	$yymain .= qq~
<table border="0" width="90%" cellspacing="1" cellpadding="3" align="center">
  <tr>
    <td width="50%" align="left"></td>
    <td width="50%" align="right">Page(s): $pageindex</td>
  </tr>
</table>
~;
	if ($entrynum eq -1 && $settings[7] eq "Administrator") { $yymain .= qq~<center><a href="$cgi;action=ajournal">$img{'jadd'}</center>~;</a>
	}
		$yytitle = $jtxt{'01'};
		&template;
		exit;
}

sub AJournal {
	&is_admin;
	$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<table border=0 width="90%" cellspacing=1 cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td colspan="2" class="titlebg" bgcolor="$color{'titlebg'}" align="left"><font size=2 class="text1" color="$color{'titletext'}">$jtxt{'08'}</font></td>
<form action="$cgi;action=ajournal2" method="post" name="postmodify" onSubmit="return submitproc()">
</tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" width="20%"><font size=2><b>$jtxt{'09'}</b></font></td>
    <td class="windowbg" bgcolor="$color{'windowbg'}" width="80%"><font size=2><input type=text name="subject" value="" size="40" maxlength="50" tabindex="1"></font></td>
</tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="20%"><font size=2><b>$jtxt{'10'}</b></font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="80%"><font size=2><textarea name="message" rows="12" cols="60" wrap="soft" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" tabindex="2"></textarea></font></td>
</tr><tr>
    <td colspan="2" class="titlebg" bgcolor="$color{'titlebg'}" align="center"><font size=2 class="text1" color="$color{'titletext'}">shortcuts (IE and NS6 only): hit alt+s to send or alt+r to reset</font><br>
		<input type="submit" name="post" value="Post" accesskey="s" tabindex="3">       <input type="reset" value="Reset" accesskey="r"></font></td>
</tr>
</form>
</table>
<script language="JavaScript"> <!--
   document.postmodify.subject.focus();
//--> </script>
~;
		$yytitle = $jtxt{'05'};
		&template;
		exit;
}

sub AJournal2 {
	# ($jsub, $jname, $jdispname, $jdate, $jmsg,$comnum) = split(/[\|]/, $_);
	&is_admin;
	$njsub = $FORM{'subject'};
	$njname = $username;
	$njdispname = $settings[1];
	$njmsg = $FORM{'message'};
	$njmsg =~ s/\cM//g;
	$njmsg =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$njmsg =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$njmsg =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&ToHTML($njmsg);
	$njmsg =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$njmsg =~ s~\n~<br>~g;
	$njedited = "0";
	$njcomnum = &RandNum;
	fopen(TFILE, "$vardir/journal/journal.txt");
		@jbuffer = <TFILE>;
	fclose(TFILE);
	fopen(JFILE, ">$vardir/journal/journal.txt", 1);
		print JFILE qq~$njsub|$njname|$njdispname|$date|$njmsg|$njedited|$njcomnum|\n~;
		print JFILE @jbuffer;
	fclose(JFILE);
	fopen(DFILE,"$vardir/journal/journal.dat") || &fatal_error("Couldn't open $vardir\journal.dat for reading.");
	$totalentries = <DFILE>;
	fclose(DFILE);
	$totalentries = $totalentries + 1;
	fopen(DFILE,">$vardir/journal/journal.dat", 1);
		print DFILE qq~$totalentries~;
	fclose(DFILE);
	fopen(CFILE, ">$vardir/journal/$njcomnum.data", 1);
		print CFILE qq~0~;
	fclose(CFILE);
	fopen(CFILE, ">$vardir/journal/$njcomnum.txt", 1);
		print CFILE qq~~;
	fclose(CFILE);
	$yySetLocation = qq~$cgi;action=journal~;
	&redirectexit;
}

sub EJournal {

	&is_admin;
	$jpostid = int( $INFO{'entry'});
	fopen(TFILE, "$vardir/journal/journal.txt");
	@entries = <TFILE>;
	fclose(TFILE);
	chomp $entries[$jpostid];
	($tjsub, $tjname, $tjdispname, $tjdate, $tjmsg, $tjedited,$tjcomnum) = split(/[\|]/, $entries[$jpostid]);
	$tjmsg =~ s/<br>/\n/ig;
	$yymain .= qq~

<table border=0 width="90%" cellspacing=1 cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td colspan="2" class="titlebg" bgcolor="$color{'titlebg'}" align="left"><font size=2 class="text1" color="$color{'titletext'}">$jtxt{'08a'}</font></td>
<form action="$cgi;action=ejournal2;entry=$jpostid" method="post" name="postmodify" onSubmit="return submitproc()">
</tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" width="20%"><font size=2><b>$jtxt{'09'}</b></font></td>
    <td class="windowbg" bgcolor="$color{'windowbg'}" width="80%"><font size=2><input type=text name="subject" value="$tjsub" size="40" maxlength="50" tabindex="1"></font></td>
</tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="20%"><font size=2><b>$jtxt{'10'}</b></font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="80%"><font size=2><textarea name="message" rows="12" cols="60" wrap="soft" tabindex="2">$tjmsg</textarea></font></td>
</tr><tr>
    <td colspan="2" class="titlebg" bgcolor="$color{'titlebg'}" align="center"><font size=2 class="text1" color="$color{'titletext'}">shortcuts (IE and NS6 only): hit alt+s to send or alt+r to reset</font><br>
		<input type="submit" name="post" value="Post" accesskey="s" tabindex="3">       <input type="reset" value="Reset" accesskey="r"></font></td>
</tr>
</form>
<script language="JavaScript"> <!--
   document.postmodify.message.focus();
//--> </script>
</table>
~;
		$yytitle = $jtxt{'06'};
		&template;
		exit;
}

sub EJournal2 {
	&is_admin;
	$jpostid = int( $INFO{'entry'});
	fopen(TFILE, "$vardir/journal/journal.txt");
	@entries = <TFILE>;
	fclose(TFILE);
	chomp $entries[$jpostid];
	($tjsub, $tjname, $tjdispname, $tjdate, $tjmsg, $tjedited,$tjcomnum) = split(/[\|]/, $entries[$jpostid]);
	$njsub = $FORM{'subject'};
	$njname = $tjname;
	$njdispname = $tjdispname;
	$njmsg = $FORM{'message'};
	&ToHTML($njmsg);
	$njmsg =~ s/\n/<br>/g;
	$njedited = "1";
	$entries[$jpostid] = qq~$njsub|$njname|$njdispname|$date|$njmsg|$njedited|$tjcomnum||\n~;
	fopen(JFILE, ">$vardir/journal/journal.txt", 1);
	print JFILE @entries;
	fclose(JFILE);
	$yySetLocation = qq~$cgi;action=journal~;
	&redirectexit;
}

sub DJournal {
	&is_admin;
	$jpostid = int( $INFO{'entry'});
	$yymain .= qq~
<table border=0 width="90%" cellspacing=1 cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td colspan="2" class="titlebg" bgcolor="$color{'titlebg'}" align="left"><font size=2 class="text1" color="$color{'titletext'}">$jtxt{'11'}</font></td>
</tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size=2><b><a href="$cgi;action=djournal2;entry=$jpostid">$jtxt{'12'}</a> - <a href="javascript:history.go(-1)">$jtxt{'13'}</a></b></font></td>
</tr>
</table>
~;
		$yytitle = $jtxt{'07'};
		&template;
		exit;
}

sub DJournal2 {
	&is_admin;
	$jpostid = int( $INFO{'entry'});

	fopen(TFILE, "$vardir/journal/journal.txt");
	@entries = <TFILE>;
	fclose(TFILE);
	chomp $entries[$jpostid];
	($tjsub, $tjname, $tjdispname, $tjdate, $tjmsg, $tjedited,$tjcomnum) = split(/[\|]/, $entries[$jpostid]);
	$entries[$jpostid] = '';
	fopen(JFILE, ">$vardir/journal/journal.txt", 1);
	print JFILE @entries;
	fclose(JFILE);
	fopen(DFILE,"$vardir/journal/journal.dat") || &fatal_error("Couldn't open $vardir\journal.dat for reading.");
	$totalentries = <DFILE>;
	fclose(DFILE);
	$totalentries = $totalentries - 1;
	fopen(DFILE,">$vardir/journal/journal.dat", 1);
		print DFILE qq~$totalentries~;
	fclose(DFILE);
	unlink ("$vardir/journal/$tjcomnum.data");
	unlink ("$vardir/journal/$tjcomnum.txt");
	$yySetLocation = qq~$cgi;action=journal~;
	&redirectexit;
}

sub BuildPageA {
	$yycounter=$counterstring;
	print header(-status=>"200 OK", -charset=>$yycharset);
	fopen(JTEMPLATE,"$vardir/journal/jtemplate.html") || die("$txt{'23'}: jtemplate.html");
	@jtemplate = <JTEMPLATE>;
	fclose(JTEMPLATE);
	for(my $i = 0; $i < @jtemplate; $i++) {
		$curline = $jtemplate[$i];
		$curline =~ s~<yabb\s+(\w+)>~${"yy$1"}~g;
		print $curline;
	}
}

sub JComments {
	&LoadCensorList;
	$jcom = $INFO{'com'};
	$comtag = -1;
	fopen(CFILE,"$vardir/journal/$jcom.txt", 1);
	@jcomments = <CFILE>;
	fclose(CFILE);

	$yymain .= qq~
<div align=right>
<font size="1">Close Window | <a href="javascript:window.close();"><b>X</b></a></font><p>
  </div>~;
	# for each comment
	foreach(@jcomments) {

	$comtag = $comtag + 1;
	chomp;
	($jcname, $jcemail, $jcdate, $jcmsg) = split(/[\|]/, $_);
	$jcdate = &timeformat($jcdate);
	
	# Censor the name and message.
	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$jcmsg =~ s~\Q$tmpa\E~$tmpb~gi;
		$jcname =~ s~\Q$tmpa\E~$tmpb~gi;
	}
	$yymain .= qq~
<table border="0" width="320" cellspacing="5" cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
<tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2>$jcmsg<BR></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" align="right"><font size=1>Posted by <a name="$comtag"></a><a href="mailto:$jcemail">$jcname</a> on $jcdate~; if ($settings[7] eq "Administrator") { $yymain .= qq~ | <font size="1"><a href="$cgi;action=jcomdel;com=$jcom;tag=$comtag">Delete</a></font>~; } $yymain .= qq~</td>
  </tr>
</table><br>
~;
}
	$yymain .= qq~
	<font size="2"><br>add a comment</font> 
<hr noshade color="$color{'bordercolor'}" size="1" width="240" align="left">
<table width="100" align="left" border="0" cellpadding="1" cellspacing="1">
<form action="$cgi;action=jcomadd;com=$jcom" method="post" name="postmodify" onSubmit="return submitproc()">
<tr>
    <td width="30" align="right"><font size=2>name:</font></td>
    <td width="70" align="left"><font size=2><input type=text name="justwork" value="" size="20" maxlength="20" tabindex="1"></font></td>
</tr>
<tr>
    <td width="30" align="right"><font size=2>email:</font></td>
    <td width="70" align="left"><font size=2><input type=text name="theemail" value="" size="20" maxlength="50" tabindex="2"></font></td>
</tr><tr>
    <td width="30" align="right" valign="top"><font size=2>comment:</font></td>
    <td width="70" align="left"><font size=2><textarea name="themessage" rows="5" cols="20" wrap="soft" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" tabindex="3"></textarea></font></td>
</tr><tr>
    <td align="right" colspan="2"><font size=2><input type="submit" name="post" value="Post" accesskey="s" tabindex="4"></font></td>
</tr>
</form>
~;
	&BuildPageA;
	exit;	
}

sub JComDel {
	&is_admin;
	$thecom = $INFO{'com'};
	$comtag = int( $INFO{'tag'});
	fopen(TFILE, "$vardir/journal/$thecom.txt");
	@cments = <TFILE>;
	fclose(TFILE);
	$cments[$comtag] = '';
	fopen(JFILE, ">$vardir/journal/$thecom.txt", 1);
	print JFILE @cments;
	fclose(JFILE);
	fopen(DFILE,"$vardir/journal/$thecom.data") || &fatal_error("Couldn't open $vardir/journal/$thecom.data $comtag for reading.");
	$totalentries = <DFILE>;
	fclose(DFILE);
	$totalentries = $totalentries - 1;
	fopen(DFILE,">$vardir/journal/$thecom.data", 1);
		print DFILE qq~$totalentries~;
	fclose(DFILE);
	$yySetLocation = qq~$cgi;action=jcomments;com=$thecom~;
	&redirectexit;
}

sub JComAdd {
	&is_admin;
	$jcom = $INFO{'com'};
	&fatal_error("$txt{'76'}") if($FORM{'theemail'} eq '');
	&fatal_error("$txt{'240'} $txt{'69'} $txt{'241'}") if($FORM{'theemail'} !~ /[\w\-\.\+]+\@[\w\-\.\+]+\.(\w{2,4}$)/);
	&fatal_error("$txt{'500'}") if(($FORM{'theemail'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($FORM{'theemail'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));
	$jcemail = $FORM{'theemail'};
	$jcwork = $FORM{'justwork'};
	$jcmsg = $FORM{'themessage'};
	$jcmsg =~ s/\cM//g;
	$jcmsg =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$jcmsg =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$jcmsg =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&ToHTML($jcmsg);
	$jcmsg =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$jcmsg =~ s~\n~<br>~g;
	if( $jcwork eq '' ) { $jcwork = "Guest"; }
	fopen(TFILE, "$vardir/journal/$jcom.txt");
		@jbuffer = <TFILE>;
	fclose(TFILE);
	fopen(JFILE, ">$vardir/journal/$jcom.txt", 1);
		print JFILE qq~$jcwork|$jcemail|$date|$jcmsg||\n~;
		print JFILE @jbuffer;
	fclose(JFILE);
	fopen(DFILE,"$vardir/journal/$jcom.data") || &fatal_error("Couldn't open $vardir/journal/$jcom.data for reading.");
	$totalentries = <DFILE>;
	fclose(DFILE);
	$totalentries = $totalentries + 1;
	fopen(DFILE,">$vardir/journal/$jcom.data", 1);
		print DFILE qq~$totalentries~;
	fclose(DFILE);
	$yySetLocation = qq~$cgi;action=jcomments;com=$jcom~;
	&redirectexit;
}

1;